<?php if(!defined('BASEPATH')) exit('No direct script access allowed');
global $g_chart_list;
$g_chart_list = array();
if(!isset($http_result, $event_result))
    return;

require_once(APPPATH. "views/dashboard/renderers.php");
require_once("view_utils.php");

define("THROUGHPUT_RX", "throughput_rx");
define("THROUGHPUT_TX", "throughput_tx");
define("HTTP_REQUESTS_PER_SEC", "http_requests_per_second");

global $g_function;
global $g_descriptivename;
global $g_detailview;
global $g_http_result;
global $g_event_result;
global $g_request;
global $g_load_links_in_frame;

$g_function = $func;
$g_descriptivename = view_utils::get_stats_group_array();
$g_detailview = "NO";
$g_http_result = $http_result;
$g_event_result = $event_result;
$g_request = ($is_ajax_request ? AJAX_REQUEST : PAGE_REQUEST);
$g_load_links_in_frame = isset($load_links_in_frame) ? $load_links_in_frame : null;
if($is_ajax_request)
{
    print "<message colname=\"" . THROUGHPUT_RX . "\" val=\"" . calculate_throughput(true) . "\"/>\n";
    print "<message colname=\"" . THROUGHPUT_TX . "\" val=\"" . calculate_throughput(false) . "\"/>\n";
    print "<message colname=\"" . HTTP_REQUESTS_PER_SEC . "\" val=\"" . get_http_requests_rate() . "\"/>\n";
    print_system_events_xml();
}
else
    print_gauges();

function print_gauges()
{
    require_once(APPPATH. "views/common/chart_classes.php");
    $chart_obj = chart_factory::get_chart_object("dial");
    print "<div class=\"gauges\" id=\"gauges_div\">\n<table cellpadding=\"1\">\n";
    print "<colgroup width=\"" . (3 * $chart_obj->width) . "\">\n";
    print "<colgroup width=\"300\">\n";
    print "<colgroup width=\"*%\">\n\t<tr>";
    print_dials();
    print_throughput($chart_obj->height);
    print_system_events_html();
    print "\n\t</tr>\n</table>\n</div>\n";
}

function print_dials()
{
    global $g_load_links_in_frame;
    print "\n\t\t<td class=\"ns_gauge_wrapper smooth_all_corner \">\n\t\t\t";
    view_utils::print_chart_url("cpu_mem_dial", $g_load_links_in_frame);
    print "\n\t\t</td>";
}

function print_throughput($height)
{
    $link_title = get_link_title("statinterface");
    print "\n\t\t<td class=\"throughput\">\n\t\t\t<table class=\"throughput_table smooth_all_corner\" >";
    print "\n\t\t\t\t<tr>\n\t\t\t\t\t<td colspan='2' class='throughput_title' title=\"$link_title\">";
    if($link_title)
        print_link("statinterface");
    print "Throughput";
    if($link_title)
        print "</a>";
    print "</td>\n\t\t\t\t</tr>";
    print "\n\t\t\t\t<tr>\n\t\t\t\t\t<td colspan='2'></td></tr>";
    print "\n\t\t\t\t<tr>\n\t\t\t\t\t<td  class=\"throughput_left_td\"><div class=\"throughput_label\">Input</div><span id=\"".THROUGHPUT_RX."\" class=\"throughput_number\">".calculate_throughput(true)."</span><span class=\"throughput_unit\"> Mbps</span></td>";
    print "\n\t\t\t\t\n\t\t\t\t\t<td><div class=\"throughput_label\">Output</div><span id=\"".THROUGHPUT_TX."\" class=\"throughput_number\">".calculate_throughput(false)."</span><span class=\"throughput_unit\"> Mbps</span></td></tr>";
    print "\n\t\t\t\t<tr>\n\t\t\t\t\t<td colspan='2'></td></tr>";
    print "\n\t\t\t\t</table>";
    $link_title = get_link_title("statprotocolhttp");
    print "\n\t\t\t<table class=\"throughput_table http_stat_table smooth_all_corner\">";
    print "\n\t\t\t\t<tr>";
    print "\n\t\t\t\t<td class='throughput_title' title=\"$link_title\">";
    if($link_title)
        print_link("statprotocolhttp");
    print "HTTP Requests/s";
    if($link_title)
        print "</a>";
    print "\n\t\t\t\t</td></tr>";
    print "\n\t\t\t\t<tr>\n\t\t\t\t\t<td></td></tr>";
    print "\n\t\t\t\t<tr>\n\t\t\t\t\t<td class=\"throughput_number\"><span id=\"" . HTTP_REQUESTS_PER_SEC . "\">" . get_http_requests_rate() . "</span></td>\n\t\t\t\t</tr>";
    print "\n\t\t\t\t<tr>\n\t\t\t\t\t<td></td></tr>";
    print "\n\t\t\t\t</table>";
    print "\n\t\t</td>";
}

function print_link($function)
{
    global $g_load_links_in_frame;
    if($g_load_links_in_frame != null)
        print "<a href='/menu/stc?func=$function' target=\"$g_load_links_in_frame\">";
    else
        print "<a href='/menu/st?cfunc=$function'>";
}

function get_link_title($link_function)
{
    global $g_descriptivename;
    return "Click to view " . $g_descriptivename[$link_function];
}

function calculate_throughput($rx)
{
    global $g_http_result;
    global $g_request;
    if(!view_utils::is_valid_stat_result($g_http_result, $g_request, false))
        return ($g_request == AJAX_REQUEST) ? htmlspecialchars("&nbsp;") : "&nbsp;";
    $cntr_name = $rx ? "rxmbitsrate" : "txmbitsrate";
    $total = 0;
    foreach($g_http_result['List'] as $obj)
        return isset($obj[$cntr_name]) ? StatisticsRenderer::getcntrvalue($obj[$cntr_name], null) : "";
}

function get_http_requests_rate()
{
    global $g_http_result;
    global $g_request;
    if(!view_utils::is_valid_stat_result($g_http_result, $g_request, false))
        return ($g_request == AJAX_REQUEST) ? htmlspecialchars("&nbsp;") : "&nbsp;";
    foreach($g_http_result['List'] as $obj)
        return isset($obj['httprequestsrate']) ? StatisticsRenderer::getcntrvalue($obj['httprequestsrate'], null) : "";
}

function print_system_events_html()
{
    print "\n\t\t<td>";
    print "\n\t\t\t<table id=\"system_log_table\" class=\"smooth_all_corner \"><tr><td>System Log";
    if((isset($_COOKIE['uatz']) && ($_COOKIE['uatz'] == "uatz")) || (isset($_SESSION['timezone_offset']) && ($_SESSION['timezone_offset'] == 0)))
        print " (GMT" . date('P') .")</td>";
    print "<td align=\"right\"><img src=\"/admin_ui/common/images/view.png\" id=\"system_events_list_find_img\" alt=\"Show search panel\" title=\"Show search panel\" class=\"pointer_cursor\" onclick=\"show_hide_find_panel('system_events_list')\"></td>";
    print "</tr>";
    print_find_panel_for_list('system_events_list');
    print "<tr><td colspan=\"2\">";
    print "\n\t\t\t<div class=\"div_for_list\"><select id=\"system_events_list\" size=\"6\" ns-min-size=\"6\" multiple onkeyup=\"on_scroll_list(this)\">";
    print_system_events_options();
    print "\n\t\t\t</select></div>";
    print "</td></tr></table>";
    print "\n\t\t</td>";
}

function print_find_panel_for_list($list_id)
{
    print "<script type=\"text/javascript\" src=\"/admin_ui/common/js/ns/list.js\">\n";
    print "</script>\n";
    print "<tr id=\"" . $list_id . "_find_row\" style=\"display: none\"><td colspan=\"2\" class=\"list_find\"><table cellpadding=\"0\" cellspacing=\"0\"><colgroup width=\"45px\"><colgroup width=\"90px\"><colgroup width=\"60px\"><colgroup width=\"*\"><colgroup width=\"16px\"><tr><td>";
    print "Criterion</td><td><select id=\"" . $list_id . "_find_row_criterion\" title=\"Select the search criterion\"  onchange=\"filter_list('$list_id')\">";
    print "<option>contains</option>";
    print "<option>not contains</option>";
    print "<option>starts with</option>";
    print "<option>ends with</option>";
    print "</select>";
    print "</td><td>Search text</td><td><input type=\"textfield\" maxlength=\"128\" id=\"" . $list_id . "_find_row_search_text\" title=\"Enter the search text (case insensitive)\" onpropertychange=\"return filter_list('$list_id')\" oninput=\"return filter_list('$list_id')\">";
    print "</td><td align=\"right\"><img src=\"/admin_ui/common/images/navigate_cross.png\" alt=\"Hide search panel\" title=\"Hide search panel\" class=\"pointer_cursor\" onclick=\"show_hide_find_panel('$list_id')\"></td></tr></table>";
    print "</td></tr>";
}

function print_system_events_xml()
{
    print "<list id=\"system_events_list\">";
    print_system_events_options();
    print "</list>";
}

function print_system_events_options()
{
    global $g_event_result;
    global $g_request;
    if(!view_utils::is_valid_stat_result($g_event_result, $g_request, false))
        return;
    foreach($g_event_result['List'] as $obj)
    {
        if(!is_array($obj))
            continue;
        $event_no = $obj["eventno"];
        $event_time = view_utils::convert_local_to_client_time($obj["time"], 'D M j H:i:s');
        $event_text = preg_replace("/\"/", "", $obj["text"]);
        $event_text = preg_replace("/\\\'/", "'", $event_text);
        $style = "";
        if(!(stripos($event_text, NS_S_UP) === false) || !(stripos($event_text, NS_S_ENABLED) === false))
            $style = "style=\"color: #219f0d\"";
        if(!(stripos($event_text, NS_S_DOWN) === false) || !(stripos($event_text, THROUGHPUT_RATE_LIMIT) === false) || !(stripos($event_text, PPS_LIMIT) === false))
            $style = "style=\"color: #ff0000\"";
        else if(!(stripos($event_text, NS_S_OFS) === false) || !(stripos($event_text, NS_S_DISABLED) === false))
            $style = "style=\"color: #ffcc33\"";
        print "<option value=\"$event_no\" title=\"$event_text\" $style>$event_time $event_text</option>";
    }
}
?>